/*
      SoundMan v0.1 - Realtime frequency analyzer
      Copyright (C) 1999 Gabor Kerenyi (wom@fireball.kalmar.hu)
*/

typedef struct complex
{
  double re,im;
};

typedef struct conf_dev
{
   char dev[128];
   int f;
   int freq;
   char device_name[256];
   char fname[256];
   long rec_pn;
   int flags;
   int ido;
}; 

typedef struct conf_pgramm
{
  int window_length;
  int pn;
  float **val;
  int window_number;
  int window_start;
  int zoom;
  int cut_value;
  int black_value;
  int con_value;
  bool cut;
  bool logcol;
  bool black;
  bool con;
};

typedef struct rgb
{
  unsigned char r,g,b;
};

typedef struct colors
{
   struct rgb ampl_background;
   struct rgb ampl_x,ampl_y;
   struct rgb ampl_xlines,ampl_ylines;
   struct rgb ampl_xtext,ampl_ytext;
   struct rgb ampl_data;
   struct rgb sgr_background;
   struct rgb sgr_x,sgr_y;
   struct rgb sgr_xlines,sgr_ylines;
   struct rgb sgr_xtext,sgr_ytext;
   struct rgb sgr_data;
   struct rgb wave_x,wave_y;
   struct rgb wave_o;
   struct rgb wave_data;
   struct rgb wave_background;
   struct rgb wave_xlines;
   struct rgb wave_xtext;
};

typedef struct conf_pspectrum
{
   int window; /*0 negyszog, 1 haromszog, 2 hanning, 3 hamming*/
   long pn;
   int freq;
   int ln;
   int displayx;  /*0 ha linearis, 1 ha logaritmikus*/
   int displayy;  /*0 ha linearis, 1 ha logaritmikus*/
   int display;   /*0, ha volanas, 1 ha oszlopos, 2 ha fuggveny szeru*/
   long maxx;
   long maxy;
   int zoomx;
   int zoomy;
   bool xyarrangers;
   bool agc;
   complex *data;
   complex *source;
   float maxpower;
   float abs_maxpower;
   double *power;
   double *phase;

};

typedef struct conf_wave
{
   int freq;
   long rec_pn;
   long maxx;
   long maxy;
   int zoomx;
   int zoomy;
   int window_length;
   int window_start;
   int window_start_pn;
   int window_length_pn;
   long ido;
   unsigned char *wave;
   int f;
};

typedef struct noise_f
{
   int fr_start;
   int fr_end;
   int time_start;
   int time_end;
   int ampl;
};

typedef struct cnf
{
  struct conf_pspectrum spect;
  struct conf_wave wave;
  struct conf_dev dev;
  struct conf_pgramm pg;
  float *noise;
  unsigned char *wnoise;
  noise_f *nf;
  colors col;
  char home[256];
  char soundconf[256];
};

typedef struct wav
{
 char riff[3];
 long data_length;
 char wid[3];
 char tmp[3];
 char fid[3];
 long id_length;
 int wave_store;
 int ch;
 long freq;
 long bps;
 int ba;
 int bitps;
 char tmp1[3];
 long dlen; 
};

void file_close(int);
